Bug 1196960 - Review Request: ghc-tf-random - High-quality splittable pseudorandom number generator
Summary: Review Request: ghc-tf-random - High-quality splittable pseudorandom number g...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: ---
Assignee: Ben Boeckel
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1081471
TreeView+ depends on / blocked
 
Reported: 2015-02-27 07:36 UTC by Jens Petersen
Modified: 2015-04-23 16:05 UTC (History)
3 users (show)

Fixed In Version: ghc-tf-random-0.5-2.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-04-21 19:32:15 UTC
mathstuf: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jens Petersen 2015-02-27 07:36:28 UTC
Spec URL: http://petersen.fedorapeople.org//ghc-tf-random.spec
SRPM URL: http://petersen.fedorapeople.org//ghc-tf-random-0.5-1.fc21.src.rpm

Description:
This package contains an implementation of a high-quality splittable
pseudorandom number generator. The generator is based on a cryptographic hash
function built on top of the ThreeFish block cipher. See the paper /Splittable
Pseudorandom Number Generators Using Cryptographic Hashing/ by Claessen, Pałka
for details and the rationale of the design.

The package provides the following:

* A splittable PRNG that implements the standard 'System.Random.RandomGen'
class.

* The generator also implements an alternative version of the
'System.Random.TF.Gen.RandomGen' class (exported from "System.Random.TF.Gen"),
which requires the generator to return pseudorandom integers from the full
32-bit range, and contains an n-way split function.

* An alternative version of the 'Random' class is provided, which is linked to
the new 'RandomGen' class, together with 'Random' instances for some integral
types.

* Two functions for initialising the generator with a non-deterministic seed:
one using the system time, and one using the '/dev/urandom' UNIX special file.

The package uses an adapted version of the reference C implementation of
ThreeFish from the reference package of the Skein hash function
(<https://www.schneier.com/skein.html>), originally written by Doug Whiting.

Please note that even though the generator provides very high-quality
pseudorandom numbers, it has not been designed with cryptographic applications
in mind.

Comment 1 Jens Petersen 2015-02-27 07:36:30 UTC
This package built on koji:  http://koji.fedoraproject.org/koji/taskinfo?taskID=9088775

Comment 2 Jens Petersen 2015-02-27 07:38:26 UTC
This is needed for QuickCheck-2.7 which in terms is needed to build recent Agda with ghc-7.8.

Comment 3 Ben Boeckel 2015-03-03 01:57:54 UTC
Needs a License: update.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.

License should be "Public Domain and (BSD or GPL)". No version for the GPL
specified.

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[?]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 266240 bytes in 29 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-tf-random-0.5-1.fc23.x86_64.rpm
          ghc-tf-random-devel-0.5-1.fc23.x86_64.rpm
          ghc-tf-random-0.5-1.fc23.src.rpm
ghc-tf-random.x86_64: W: spelling-error Summary(en_US) splittable -> split table, split-table, hospitable
ghc-tf-random.x86_64: W: spelling-error Summary(en_US) pseudorandom -> pseudo random, pseudo-random, pseudonymous
ghc-tf-random.x86_64: W: spelling-error %description -l en_US splittable -> split table, split-table, hospitable
ghc-tf-random.x86_64: W: spelling-error %description -l en_US pseudorandom -> pseudo random, pseudo-random, pseudonymous
ghc-tf-random.x86_64: W: spelling-error %description -l en_US cryptographic -> cryptography, cryptographer, crystallographic
ghc-tf-random.x86_64: W: spelling-error %description -l en_US RandomGen -> Random Gen, Random-Gen, Random-gen
ghc-tf-random.x86_64: W: spelling-error %description -l en_US initialising -> initializing, initialing, initiating
ghc-tf-random.x86_64: W: spelling-error %description -l en_US dev -> deb, derv, div
ghc-tf-random.x86_64: W: spelling-error %description -l en_US urandom -> random, u random
ghc-tf-random.x86_64: W: spelling-error %description -l en_US https -> HTTP
ghc-tf-random.x86_64: W: spelling-error %description -l en_US www -> WWW, wow
ghc-tf-random.x86_64: W: spelling-error %description -l en_US schneier -> Schneider
ghc-tf-random.x86_64: W: spelling-error %description -l en_US html -> HTML, ht ml, ht-ml
ghc-tf-random.src: W: spelling-error Summary(en_US) splittable -> split table, split-table, hospitable
ghc-tf-random.src: W: spelling-error Summary(en_US) pseudorandom -> pseudo random, pseudo-random, pseudonymous
ghc-tf-random.src: W: spelling-error %description -l en_US splittable -> split table, split-table, hospitable
ghc-tf-random.src: W: spelling-error %description -l en_US pseudorandom -> pseudo random, pseudo-random, pseudonymous
ghc-tf-random.src: W: spelling-error %description -l en_US cryptographic -> cryptography, cryptographer, crystallographic
ghc-tf-random.src: W: spelling-error %description -l en_US RandomGen -> Random Gen, Random-Gen, Random-gen
ghc-tf-random.src: W: spelling-error %description -l en_US initialising -> initializing, initialing, initiating
ghc-tf-random.src: W: spelling-error %description -l en_US dev -> deb, derv, div
ghc-tf-random.src: W: spelling-error %description -l en_US urandom -> random, u random
ghc-tf-random.src: W: spelling-error %description -l en_US https -> HTTP
ghc-tf-random.src: W: spelling-error %description -l en_US www -> WWW, wow
ghc-tf-random.src: W: spelling-error %description -l en_US schneier -> Schneider
ghc-tf-random.src: W: spelling-error %description -l en_US html -> HTML, ht ml, ht-ml
3 packages and 0 specfiles checked; 0 errors, 26 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
ghc-tf-random-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(tf-random-0.5-fa86e7525d6f08f8811267a535f6be29)
    ghc-compiler
    ghc-devel(base-4.7.0.2-cb23b5265b6e147094c0cd9ac819acb1)
    ghc-devel(primitive-0.5.2.1-1efb6a710569a6a23b761d538e2c75d2)
    ghc-devel(random-1.0.1.1-cb9cbae5b74a92852df1adbb0a3aa8d8)
    ghc-devel(time-1.4.2-192d26f44a2c945780bbb921626c3399)
    ghc-tf-random(x86-64)

ghc-tf-random (rpmlib, GLIBC filtered):
    ghc(base-4.7.0.2-cb23b5265b6e147094c0cd9ac819acb1)
    ghc(primitive-0.5.2.1-1efb6a710569a6a23b761d538e2c75d2)
    ghc(random-1.0.1.1-cb9cbae5b74a92852df1adbb0a3aa8d8)
    ghc(time-1.4.2-192d26f44a2c945780bbb921626c3399)
    libHSarray-0.5.0.0-ghc7.8.4.so()(64bit)
    libHSbase-4.7.0.2-ghc7.8.4.so()(64bit)
    libHSdeepseq-1.3.0.2-ghc7.8.4.so()(64bit)
    libHSghc-prim-0.3.1.0-ghc7.8.4.so()(64bit)
    libHSinteger-gmp-0.5.1.0-ghc7.8.4.so()(64bit)
    libHSold-locale-1.0.0.6-ghc7.8.4.so()(64bit)
    libHSprimitive-0.5.2.1-ghc7.8.4.so()(64bit)
    libHSrandom-1.0.1.1-ghc7.8.4.so()(64bit)
    libHStime-1.4.2-ghc7.8.4.so()(64bit)
    libc.so.6()(64bit)
    libgmp.so.10()(64bit)
    rtld(GNU_HASH)



Provides
--------
ghc-tf-random-devel:
    ghc-devel(tf-random-0.5-fa86e7525d6f08f8811267a535f6be29)
    ghc-tf-random-devel
    ghc-tf-random-devel(x86-64)
    ghc-tf-random-static

ghc-tf-random:
    ghc(tf-random-0.5-fa86e7525d6f08f8811267a535f6be29)
    ghc-tf-random
    ghc-tf-random(x86-64)
    libHStf-random-0.5-ghc7.8.4.so()(64bit)



Unversioned so-files
--------------------
ghc-tf-random: /usr/lib64/ghc-7.8.4/tf-random-0.5/libHStf-random-0.5-ghc7.8.4.so

Source checksums
----------------
https://hackage.haskell.org/package/tf-random-0.5/tf-random-0.5.tar.gz :
  CHECKSUM(SHA256) this package     : 2e30cec027b313c9e1794d326635d8fc5f79b6bf6e7580ab4b00186dadc88510
  CHECKSUM(SHA256) upstream package : 2e30cec027b313c9e1794d326635d8fc5f79b6bf6e7580ab4b00186dadc88510


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review --mock-config fedora-rawhide-x86_64-bb-tmpfs --bug 1196960
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Haskell, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 4 Jens Petersen 2015-03-03 04:33:04 UTC
Thanks for pointing out about the license.

I have updated it to "BSD and Public Domain" and added
a comment noting also about the GPL option for one header file.
This also uses %license - though I had to rm LICENSE.
(Maybe ghc-rpm-macros should configure with --docdir=/dev/null perhaps.)

Spec: http://petersen.fedorapeople.org/reviews/ghc-tf-random/ghc-tf-random.spec
SRPM: http://petersen.fedorapeople.org/reviews/ghc-tf-random/ghc-tf-random-0.5-2.fc21.src.rpm

Comment 5 Jens Petersen 2015-03-06 03:29:09 UTC
How does it look? :)
This is the last dep hurdle to getting Agda built with ghc-7.8 for F22+

Comment 6 Jens Petersen 2015-03-18 08:45:17 UTC
I guess if one wanted to be more precise about the header file,
the License tag could also be something like
"BSD and Public Domain and (BSD or GPL)".

Anyway all the consumers of tf-random
<http://packdeps.haskellers.com/reverse/tf-random>
are either BSD or MIT so we are probably splitting hairs here.

Comment 7 Ben Boeckel 2015-03-18 12:59:57 UTC
License in the spec is fine with me since it has the comment on it for the header.

Comment 8 Jens Petersen 2015-03-19 00:36:56 UTC
Thanks for the review!


New Package SCM Request
=======================
Package Name: ghc-tf-random
Short Description: Pseudorandom number generator
Upstream URL: https://hackage.haskell.org/package/tf-random
Owners: petersen
Branches: f22 f21 epel7
InitialCC: haskell-sig

Comment 9 Gwyn Ciesla 2015-03-19 12:58:20 UTC
Git done (by process-git-requests).

Comment 10 Fedora Update System 2015-03-20 03:08:34 UTC
ghc-tf-random-0.5-2.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/ghc-tf-random-0.5-2.fc22

Comment 11 Fedora Update System 2015-03-20 03:09:44 UTC
ghc-tf-random-0.5-2.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/ghc-tf-random-0.5-2.fc21

Comment 12 Fedora Update System 2015-03-21 04:59:37 UTC
ghc-tf-random-0.5-2.fc22 has been pushed to the Fedora 22 testing repository.

Comment 13 Fedora Update System 2015-04-21 19:32:15 UTC
ghc-tf-random-0.5-2.fc22 has been pushed to the Fedora 22 stable repository.

Comment 14 Fedora Update System 2015-04-23 16:05:06 UTC
ghc-tf-random-0.5-2.fc21 has been pushed to the Fedora 21 stable repository.


Note You need to log in before you can comment on or make changes to this bug.